<template>
	<div :class="$style.tooltip">
		<GlobalEvents v-if="isOpen" @click.capture.prevent.stop="close" />

		<div :class="$style.tooltipInner">
			<button
				type="button"
				:class="$style.tooltipButton"
				:aria-controls="`tooltip-${id}-content`"
				:aria-expanded="String(isOpen)"
				aria-label="More information"
				@click="open"
				@blur="close"
			>
				<BaseIcon :class="[$style.tooltipIcon, $style[theme]]" name="info" title="Details" />
			</button>

			<div v-if="isOpen" :id="`tooltip-${id}-content`" :class="contentClasses" :style="contentStyle">
				<div :class="$style.tooltipContentInner"><slot /></div>
			</div>
		</div>
	</div>
</template>

<script>
export default {
	props: {
		theme: {
			type: String,
			default: 'dark',
			validator: (val) => ['light', 'dark'].includes(val),
		},

		position: {
			type: String,
			default: 'bottom right',
		},

		contentClass: {
			type: String,
			default: '',
		},

		width: {
			type: Number,
			default: 100,
		},
	},

	data() {
		return { id: Math.floor(Math.random() * 1000000000), isOpen: false, contentStyle: {} };
	},

	computed: {
		normalizedPosition() {
			let { position } = this;
			let x = 'right';
			let y = 'bottom';
			position = position.split(' ');

			if (position[0] === 'left' || position[1] === 'left') {
				x = 'left';
			}

			if (position[0] === 'top' || position[1] === 'top') {
				y = 'top';
			}

			return { x, y };
		},

		contentClasses() {
			const {
				normalizedPosition: { x, y },
				$style,
				contentClass,
			} = this;

			return [$style.tooltipContent, $style[x], $style[y], contentClass];
		},
	},

	watch: {
		isOpen(val) {
			const op = val ? 'add' : 'remove';
			document.body.classList[op](this.$style.bodyClickableOnTouch);

			if (val) {
				const { left: leftBase, width } = this.$el.getBoundingClientRect();
				const left = leftBase + Math.floor(width / 2);
				const right = window.innerWidth - left;
				const isOnRight = this.normalizedPosition.x === 'right';
				const maxWidth = window.innerWidth - 20 - (isOnRight ? left : right);
				const fixedWidth = Math.min(this.width, maxWidth);
				this.contentStyle = { width: `${fixedWidth}px` };
			}
		},
	},

	methods: {
		open() {
			this.isOpen = true;
		},

		close() {
			this.isOpen = false;
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.bodyClickableOnTouch {
	@media (hover: none) {
		cursor: pointer;
	}
}

.tooltipInner {
	position: relative;
}

.tooltipIcon {
	display: block;
	width: 1.6rem;
	height: 1.6rem;
	fill: color('black');

	&.light {
		fill: #d7d5d4;
	}
}

.tooltipContent {
	position: absolute;
	z-index: 1;
	padding: size('xxs') size('xs');
	background-color: color('black');
	border-radius: 0.4em;

	&::after {
		position: absolute;
		width: 0;
		height: 0;
		content: '';
	}

	&.top {
		bottom: calc(100% + 0.9rem);

		&::after {
			bottom: -0.6rem;
		}
	}

	&.bottom {
		top: 1.6rem + 0.8rem + 0.6rem;

		&::after {
			top: -0.8rem;
		}
	}

	&.left {
		right: 0.8rem;

		&::after {
			right: 0;
		}
	}

	&.right {
		left: 0.8rem;

		&::after {
			left: 0;
		}
	}

	&.top.left {
		border-bottom-right-radius: 0;

		&::after {
			border-color: transparent color('black') transparent transparent;
			border-width: 0 1.6rem 0.8rem 0;
		}
	}

	&.top.right {
		border-bottom-left-radius: 0;

		&::after {
			border-color: color('black') transparent transparent transparent;
			border-width: 0.8rem 1.6rem 0 0;
		}
	}

	&.bottom.left {
		border-top-right-radius: 0;

		&::after {
			border-color: transparent transparent color('black') transparent;
			border-width: 0 0 0.8rem 1.6rem;
		}
	}

	&.bottom.right {
		border-top-left-radius: 0;

		&::after {
			border-color: transparent transparent transparent color('black');
			border-width: 0.8rem 0 0 1.6rem;
		}
	}
}

.tooltipContentInner {
	color: color('white');

	@include use-text-style('type');
	@include use-text-style('type-100');

	ul,
	ol {
		padding-left: 1.1em;
	}

	p,
	ul,
	ol {
		&:not(:last-child) {
			margin-bottom: size('s');
		}
	}

	strong {
		line-height: 1.7;
	}
}
</style>
